;;;______________________________________________________________________
;;; Nom du Fichier       : Tampon.lsp
;;; Programmation        : (c) Roger ROSEC - roger.rosec@chello.fr
;;; et documentation     :  
;;; Version AutoCAD      : Toutes ( vrifier)
;;; Description          : Insre un bloc contennt un attribut donnant le nom du 
;;;                      : fichier, le nom d'utilisateur, la date et l'heure puis 
;;;                      : lance la commande Traceur.
;;;                      : Si l'attribut est dj insr, le met  jour
;;; Remarques	         : Programme Stamp en anglais
;;; Date de cration     : 1995
;;; Date dernire modif. : 10/10/2000
;;; 			 : Modifi d'aprs suggestion de Pierre LOUISET 09/09/2000
;;; 			 : pierre.louiset@i-carre.net ou pierre.louiset@equipement.gouv.fr
;;; Objet modif.         : Ajout gestion d'erreur et vite de planter si le bloc
;;;			 : n'est plus affich dans le dessin (a t effac)
;;; FONCTIONS            : TAMPON



(defun c:tampon (/ bloc1 echo1 lup1 TouTampon Sub_InsertionBloc Sub_Misajour) 
  (setq echo1 (getvar "cmdecho"))    ; svg cmdecho
  (setvar "cmdecho" 0)               ; 
  (setq lup1 (getvar "luprec"))      ; svg luprec
  (setvar "luprec" 6)                ; nombre de dcimales
  ;; ======================================================================
  ;; La suite de cette fonction se trouve  la fin de fichier
  ;;------------------------------------------------------------------

  (defun Sub_InsertionBloc (/ Question1 AffBoite Echel1 pt1) 
    ;; routine d'insertion du bloc contenant l'attribut
    (setq Question1 (getvar "attreq")) ; svg attreq
    (setvar "attreq" 0)                ; pour utiliser la valeur par dfaut de l'attribut
    (setq AffBoite (getvar "attdia"))  ; svg attdia
    (setvar "attdia" 0)                ; pour interdire affichage bote de dialogue
   				       ; d'insertion des attributs

    (setq Echel1 (getvar "dimscale"))  			    ; facteur d'chelle global
    ;(setq Echel1 (0.8 ))  			    ; facteur d'chelle global
    
    
    (setq pt1 (getpoint "\nPoint d'insertion du tampon : "));punto di inserzione del blocco tampon

    ;(setq pt1x (120.0));punto di inserzione del blocco tampon
    ;(setq pt1y (4.50))
    
    (if (= pt1 nil) 
      (exit)
    )                              
    ;; 'pause' dans la ligne suivante permet de choisir l'angle d'insertion. Vous pouvez
    ;; remplacer par 0 pour mettre le bloc toujours horizontal ou 90 pour vertical
    ;(command "_insert" "$tampon$" pt1 0.8 0.8 "") 
    (command "_insert" "$tampon$" pt1  0.8 0.8 "") 
    
    (setvar "attreq" Question1)      ; restauration valeur attreq avant programme
    (setvar "attdia" AffBoite)       ; restauration valeur attdia avant programme
    (princ)
  ) 
  (defun Sub_Misajour (/ Mois Jour Annee Texte1 Chemin LgNomDessin NomDessin 
                         NomUser NbTampon Cpt1 EntTamp Ent_dansBloc NomEnt NomAtt 
                         NewAtt ChgAtt
                      ) 
    (setq NomDessin (getvar "dwgname")   ; obtention du nom du dessin
          LgNomDessin (strlen NomDessin) ; obtention longueur du nom du dessin   
          Chemin (getvar "dwgprefix")    ; obtention chemin du rpertoire de dessin
    )
    (if (<= LgNomDessin 12)          ; si la longueur du nom est infrieure  13
      (setq NomDessin (strcat Chemin NomDessin)) ; on ajoute le chemin
    ) 
    (setq Mois (substr (rtos (getvar "cdate") 2) 5 2) 
          Jour (substr (rtos (getvar "cdate") 2) 7 2) 
          Annee (substr (rtos (getvar "cdate") 2) 3 2) 
          Heure (substr (rtos (getvar "cdate") 2) 10 2) 
          Minute (substr (rtos (getvar "cdate") 2) 12 2) 
          NomUser (getvar "loginname") ; obtention du nom d'utilisateur
    )
    (if (= NomUser "")               ; s'il est vide, on le demande
      (setq NomUser (getstring "\nNom d'utilisateur : "))
    )                                
    ;; La ligne suivante donne la ligne qui sera affiche. Vous pouvez supprimez des infos.
;    (setq Texte1 (strcat NomDessin " " NomUser "  " Jour "\\" Mois "\\" Annee "  " Heure ":" Minute))                 
;(setq T2 "modif le " )
 (setq Texte1 (strcat NomDessin "  " Jour "\\" Mois "\\" Annee "  " Heure ":" Minute))                 

    ;; recherche de tous les blocs $tampon$ du dessin
    (setq TouTampon (ssget "X" '((2 . "$tampon$"))) 
          NbTampon (sslength TouTampon) 	; nbre de blocs $tampon$ dans le dessin
          Cpt1 0				; drapeau compteur de blocs $Tampon$)
    ) 
    (repeat NbTampon                 		; tant qu'il y a des $tampon$
      ;; retourne dans EntTamp la liste des donnes du numro Cpt1 de TouTampon
      (setq EntTamp (entget (ssname TouTampon Cpt1)) 
            Cpt1 (+ Cpt1 1)          ; incrmente le compteur de blocs $tampon$
      )                              ; si l'entit est un bloc
      (if (= (cdr (assoc 0 EntTamp)) "INSERT") 
        (progn
          (setq Ent_dansBloc 1)      ; Drapeau attribut
          (while Ent_dansBloc        ; tant qu'il y a des entits dans le bloc
            ;; Nom de l'entit suivante dans le bloc
            (setq NomEnt (entget (entnext (cdr (assoc -1 EntTamp))))) 
	    ;; si cette entit est un attribut
            (if (= (cdr (assoc 0 NomEnt)) "ATTRIB") 
              (progn                 
		;; si le nom de l'tiquette de l'attribut est "DATE_TAMPON"
                (if (= (cdr (assoc 2 NomEnt)) "DATE_TAMPON") 
                  (progn
                    (setq NomAtt (assoc 1 NomEnt) ; valeur de l'attribut (associe  1)
                          NewAtt (cons 1 Texte1) ; construction paire pointe)
                          ChgAtt (subst NewAtt NomAtt NomEnt) ; remplace les valeurs
                    )                
		    ;; modifie les donnes de l'attribut
                    (entmod ChgAtt)
                  )                  ; progn
                )                    ; if
              )                      ; progn
            )                        ; if
            ;; si on atteint la fin du bloc
            (if (= (cdr (assoc 0 NomEnt)) "SEQEND") 
              (setq Ent_dansBloc nil)
            ) 
            (setq EntTamp NomEnt)
          ) 			     ; retour  while
        )                            ; progn
      )                              ; if retour s'il y a encore des blocs
    )                                ; repeat
    (princ) 
    (setvar "cmdecho" echo1)
    (setvar "luprec" lup1)           ; nombre de dcimales
    (command "_regen") 
    (princ)
  ) 
  ;; gestion des erreurs
  (defun BiE_Error (*msg) 
    (if (and (/= *msg "Fonction annule") 
          (/= *msg "Fonction annule") 
          (/= *msg "Function cancelled")
        ) 
      (princ (strcat "\nErreur : " *msg)) 
      (princ)
    ) 
    (setq *error* $OldError)
    (setvar "cmdecho" echo1)
    (setvar "luprec" lup1)           ; nombre de dcimales
    (princ)
  )                                  
;;--------------Suite fonction C:TAMPON  ----
;;-------------------------------------------
  ;; Pour gestion des erreurs    
  (setq $OldError *error* 
        *error* BiE_Error)           
  ;; Est ce que le bloc $tampon$ a dj t insr dans le dessin ?
  (setq bloc1 (tblsearch "block" "$tampon$"))
  (cond
    ((= bloc1 nil) (Sub_InsertionBloc) ; si non aller  Sub_InsertionBloc
     (Sub_Misajour)                  ; puis  Sub_Misajour
    )
    ((= (ssget "X" '((2 . "$tampon$"))) nil)
    ;; si le bloc existe dans la base de donnes du dessin mais a t effac
     (Sub_InsertionBloc)
	(Sub_Misajour)
    )
    ((/= bloc1 nil) (Sub_Misajour))  ; si le bloc existe, aller  Sub_Misajour
  )                                  
  ;; Force l'affichage de la boite de dialogue de la commande suivante (traceur) 
  (initdia)                          
  ;; la ligne suivante lance la commande traceur. Vous pouvez la supprimer sans problme.
  ;(command "_plot") 
  (princ)
) 

